#include<stdio.h>

#define BUFFER_SIZE 1024000
#define TRUE 1

typedef unsigned char byte;

unsigned char buffer[BUFFER_SIZE];

int encode(FILE *fp,byte *img,int mx);

/* main֐ */
int main(int ac,char *av[])
{
    FILE *fp_i,*fp_o;
    int i,c;

    if(ac<3) {
        return(1);
    }
    fp_i=fopen(av[1],"rb");
    if(fp_i==NULL) {
        fprintf(stderr,"Input File cannot openn");
        return(1);
    }
    i=0;
    while(i<BUFFER_SIZE && (c=fgetc(fp_i))!=EOF) {
        buffer[i]=c;
        i++;
    }
    fclose(fp_i);
    fp_o=fopen(av[2],"wb");
    if(fp_o==NULL) {
        fprintf(stderr,"Output File cannot openn");
        return(1);
    }
    encode(fp_o,buffer,i);
    fclose(fp_o);
    return 0;
}

/* x̐߂ */
int sgni(int x)
{
    if(x<0) return -1;
    if(x>0) return 1;
    return 0;
}

/* x̐Βl߂ */
int absi(int x)
{
    if(x<0) return -x;
    return x;
}

/* 4oCg̐lf[^t@Co͂ */
int fputLong(long num,FILE *fp)
{
    fputc((num>>24) & 0xff,fp);
    fputc((num>>16) & 0xff,fp);
    fputc((num>>8)  & 0xff,fp);
    fputc((num)     & 0xff,fp);
    return 0;
}

#define N 1000
#define NODATA 2100000000

/* nt}ؗp̔z */
int l_node[2*N],r_node[2*N];
int parent[2*N];

/* opxe[ut@Co */
int outputHist(int *hist,int nn,FILE *fp)
{
    int i;

    for(i=0;i<nn;i++)
        fputLong(hist[i],fp);
    return TRUE;
}

/* ŏpx2߂ */
int getMin2(int *hist,int hm,int *d1,int *d2)
{
    int i;
    int min;

    min=NODATA-1;
    *d1= *d2= -100;
    for(i=0;i<hm;i++) {
        if(hist[i]<min) {
            *d1=i;
            min=hist[i];
        }
    }
    min=NODATA-1;
    for(i=0;i<hm;i++) {
        if(i!=(*d1) && hist[i]<min) {
            *d2=i;
            min=hist[i];
        }
    }
    return 0;
}

/* nt}؂̍쐬 */
int makeTree(int *hist,int n)
{
    int hm_data;
    int d1,d2,i;

    hm_data=n;

    /*  */
    for(i=0;i<2+N;i++) {
        l_node[i]=r_node[i]=parent[i]=0;
    }

    while(1) {
        /* ŏpx2߂ */
        getMin2(hist,hm_data,&d1,&d2);
        /* ŏlƂȂ̂ȂΏI */
        if(d1<0 || d2<0) break;
        l_node[hm_data]=d1;
        r_node[hm_data]=d2;
        parent[d1]=hm_data;
        parent[d2]= -hm_data;
        hist[hm_data]=hist[d1]+hist[d2];
        hist[d1]=NODATA;
        hist[d2]=NODATA;
        hm_data++;
    }
    return hm_data;
}

static int bits=0;
static int bdata=0;

/* rbgo͏̏ */
int fputBitInit()
{
    bits=0;
    bdata=0;
    return 0;
}

/* 1rbgo */
int fputBit(int bit,FILE *fp)
{
    bdata=(bdata<<1)|bit;
    bits++;
    if(bits>=8) {
        fputc(bdata,fp);
        bits=0;
        bdata=0;
    }
    return 0;
}

/* ܂rbgo */
int flushBit(FILE *fp)
{
    int i;

    for(i=0;i<7;i++) {
        fputBit(0,fp);
    }
    return 0;
}

/* nt}o */
int outputEncode(int val,int end,FILE *fp)
{
    int c;
    int code[100];
    int now,i;
    int s1,a1;

    c=0;
    now=val;
    while(1) {
        s1=sgni(parent[now]);
        a1=absi(parent[now]);
        if(s1<0) code[c++]=1;
        else code[c++]=0;
        if(a1==end-1) break;
        now=a1;
    }
    for(i=c-1;i>=0;i--) {
        fputBit(code[i],fp);
    }
    return 0;
}

/* kC */
int encode(FILE *fpo,unsigned char *data,int size)
{
    int i;
    int datas;
    int hist[N*2];

    /* f[^lƂ̓opx߂ */
    for(i=0;i<N*2;i++) hist[i]=0;
    for(i=0;i<size;i++) hist[data[i]]++;
    fputLong(size,fpo);
    outputHist(hist,N,fpo);
    datas=makeTree(hist,N);
    fputBitInit();
    for(i=0;i<size;i++) {
        outputEncode(data[i],datas,fpo);
    }
    flushBit(fpo);
    return 0;
}
